<?php

include_once "ManufacturerInterface.php";

/**
 * Class AbstractManufacturer
 *
 * Date: 26.03.13
 * Time: 15:13
 * @author Thomas Joußen <tjoussen@databay.de>
 */
abstract class AbstractManufacturer implements ManufacturerInterface
{

    /**
     * Matches a delivered string with a the pattern returned by getPattern implemented in the explicit Manufacturer
     *
     * @param string $subject
     * @throws UnableToParseCondition
     *
     * @see ManufacturerInterface::getPattern()
     * @return array
     */
    public function match($subject)
    {
        $matches = array();
        $num_matches = preg_match_all($this->getPattern(), $subject, $matches);

        if ($num_matches == 0) {
            require_once __DIR__ . '/../Exception/UnableToParseCondition.php';
            throw new UnableToParseCondition($subject);
        }
        // Trims each element in the matches array
        $matches = array_map(function ($element) {
            return trim($element);
        }, $matches[0]);

        return $matches;
    }
}
