<?php
/* Copyright (c) 1998-2013 ILIAS open source, Extended GPL, see docs/LICENSE */

/**
 * Class ilObjQuestionSetPoolListGUI
 *
 * Date: 01.10.13
 * Time: 13:22
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilObjQuestionSetPoolListGUI extends ilObjectPluginListGUI
{
    public function getGuiClass()
    {
        return 'ilObj' . ilQuestionSetPoolPlugin::getName() . 'GUI';
    }

    public function initCommands()
    {
        $this->copy_enabled = true;

        return array(
            array(
                'permission' => 'read',
                'cmd' => 'infoScreen',
                'default' => true
            ),
            array(
                'permission' => 'write',
                'cmd' => 'ilQuestionSetPoolPropertiesGUI.edit',
                'default' => false
            )
        );
    }

    public function initType()
    {
        $this->setType(ilQuestionSetPoolPlugin::getPluginId());
    }

    /**
     * @return array
     */
    public function getProperties()
    {
        /**
         * @var $lng ilLanguage
         */
        global $lng;

        $props = array();
        include_once "class.ilObjQuestionSetPoolAccess.php";

        if (!ilObjQuestionSetPoolAccess::checkOnline($this->obj_id)) {
            $props[] = array("alert" => true, "property" => $lng->txt("status"),
                             "value" => $lng->txt("offline"));
        }

        return $props;
    }
}
