<?php

/**
 * Class ilQuestionSetPoolJumpConditionsProvider
 *
 * Date: 05.12.13
 * Time: 12:30
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilQuestionSetPoolJumpConditionsProvider extends ilPluginTableDatabaseDataProvider
{

    /**
     * @return string
     */
    protected function getSelectPart()
    {
        return "con.*, qst.question_index";
    }

    /**
     * @return string
     */
    protected function getFromPart()
    {
        return "rep_robj_xqsp_jmp_con con";
    }

    /**
     * @return string
     */
    protected function getJoinPart()
    {
        return join(" ", array(
                "INNER JOIN rep_robj_xqsp_node n ON n.id = con.node_fi",
                "INNER JOIN rep_robj_xqsp_path p ON p.id = n.path_fi",
                "LEFT JOIN rep_robj_xqsp_qs_qst qst ON qst.questionset_fi = p.questionset_fi AND qst.question_fi = con.question_fi"
            ));
    }

    /**
     * @param array $filter
     *
     * @return string
     */
    protected function getWherePart(array $filter)
    {
        return "con.node_fi = " . $this->db->quote($filter['node_fi']);
    }

    /**
     * @return string
     */
    protected function getGroupByPart()
    {
        return "";
    }

    /**
     * @param array $filter
     *
     * @return string
     */
    protected function getHavingPart(array $filter)
    {
        return "";
    }

    /**
     * @param array $params
     *
     * @return string
     */
    protected function getOrderByPart(array $params)
    {
        return "con.sorting ASC";
    }
}
