<?php

/**
 * Class ilConditionInputGUI
 *
 * Date: 10.01.14
 * Time: 13:57
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilConditionInputGUI extends ilTextInputGUI
{
    public function checkInput()
    {
        global $DIC;
        $lng = $DIC->language();

        $_POST[$this->getPostVar()] = ilUtil::stripOnlySlashes($_POST[$this->getPostVar()]);
        if ($this->getRequired() && trim($_POST[$this->getPostVar()]) == "") {
            $this->setAlert($lng->txt("msg_input_is_required"));

            return false;
        } elseif (strlen($this->getValidationRegexp())) {
            if (!preg_match($this->getValidationRegexp(), $_POST[$this->getPostVar()])) {
                $this->setAlert(
                    $this->getValidationFailureMessage() ?
                         $this->getValidationFailureMessage() :
                         $lng->txt('msg_wrong_format')
                );
                return false;
            }
        }

        return $this->checkSubItemsInput();
    }
}
