<?php declare(strict_types=1);

/* Copyright (c) 1998-2020 ILIAS open source, Extended GPL, see docs/LICENSE */

use PHPUnit\Framework\TestCase;
use ILIAS\DI\Container;
use PHPUnit\Framework\MockObject\MockObject;

/**
 * Class TestBaseCase
 * @author Marvin Beym <mbeym@databay.de>
 */
class QuestionSetPoolBaseTest extends TestCase
{
    protected Container $dic;

    protected function setUp() : void
    {
        $this->dic = new Container();
        $GLOBALS['DIC'] = $this->dic;

        parent::setUp();
    }

    /**
     * @return mixed|MockObject|ilTabsGUI
     */
    protected function addGlobal_ilTabs()
    {
        $mock = $this->getMockBuilder("ilTabsGUI")->disableOriginalConstructor()->getMock();
        $this->setGlobalVariable("ilTabs", $mock);
        return $mock;
    }

    /**
     * @return mixed|MockObject|ilDBInterface
     */
    protected function addGlobal_ilDB()
    {
        $mock = $this->createMock(ilDBInterface::class);
        $this->setGlobalVariable("ilDB", $mock);
        return $mock;
    }

    /**
     * @param string $name
     * @param mixed  $value
     */
    protected function setGlobalVariable(string $name, $value) : void
    {
        global $DIC;

        $GLOBALS[$name] = $value;

        unset($DIC[$name]);
        $DIC[$name] = $GLOBALS[$name];
    }
}
