<?php

use PHPUnit\Framework\TestSuite;

/**
 * Class ilQuestionSetPoolTestSuite
 *
 * Date: 24.09.13
 * Time: 12:16
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilQuestionSetPoolTestSuite extends TestSuite
{
    public static function suite()
    {
        $suite = new self();

        foreach (new RegExIterator(
            new RecursiveIteratorIterator(
                         new RecursiveDirectoryIterator(__DIR__, FilesystemIterator::SKIP_DOTS),
                         RecursiveIteratorIterator::LEAVES_ONLY
                     ),
            '/BaseTest\.php$/'
        ) as $file) {
            /** @var SplFileInfo $file */
            require_once $file->getPathname();
        }

        foreach (new RegExIterator(
            new RecursiveIteratorIterator(
                         new RecursiveDirectoryIterator(__DIR__, FilesystemIterator::SKIP_DOTS),
                         RecursiveIteratorIterator::LEAVES_ONLY
                     ),
            '/(?<!Base)Test\.php$/'
        ) as $file) {
            /** @var SplFileInfo $file */
            require_once $file->getPathname();

            $className = preg_replace('/(.*?)(\.php)/', '$1', $file->getBasename());
            if (class_exists($className)) {
                $reflection = new ReflectionClass($className);
                if (
                    !$reflection->isAbstract() &&
                    !$reflection->isInterface() &&
                    $reflection->isSubclassOf(\PHPUnit\Framework\TestCase::class)) {
                    $suite->addTestSuite($className);
                }
            }
        }

        return $suite;
    }
}
