<?php

use PHPUnit\Framework\TestCase;

/**
 * Class ilPluginTableDatabaseDataProviderTest
 *
 * Date: 24.09.13
 * Time: 13:33
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilPluginTableDatabaseDataProviderTest extends QuestionSetPoolBaseTest
{

    /**
     * @var ilQuestionSetPoolQuestionsBrowserProvider
     */
    protected $provider;

    public function setUp() : void
    {
        parent::setUp();
        $ilDB_mock = $this->addGlobal_ilDB();
        $ilDB_mock
            ->expects($this->any())
            ->method("quote")
            ->with(2)
            ->will($this->returnValue(2));

        $this->provider = new ilPluginTableDatabaseDataProviderMock();
    }

    public function testIsLoaded()
    {
        $this->assertFalse($this->provider->isLoaded(), "The Provider isn't loaded");
        $this->provider->setLoaded(true);
        $this->assertTrue($this->provider->isLoaded(), "The Provider is loaded");
    }
}
